Option Compare Text     ' Filenames are compared using text semantics.
Option Explicit On 
Option Strict On

Imports Microsoft.VisualBasic
Imports MvpsOrg.Utilities
Imports System
Imports System.Drawing
Imports System.IO
Imports System.Threading
Imports System.Windows.Forms

''' <summary>
'''   The program's main form.
''' </summary>
Public Class MainForm
    Inherits System.Windows.Forms.Form

    Private Enum OperationMode
        Idle
        Enumerating
    End Enum

    Private m_Mode As OperationMode
    Private m_StatusBarGraphics As Graphics
    Private m_StatusBarTextWidth As Integer
    Private WithEvents m_Enumerator As New FileSystemEnumerator

    Private Delegate Sub EnumerationDirectoryChangedDelegate(ByVal sender As Object, ByVal e As EnumerationDirectoryChangedEventArgs)
    Private Delegate Sub FileFoundDelegate(ByVal sender As Object, ByVal e As FileFoundEventArgs)
    Private Delegate Sub SearchFinishedDelegate(ByVal Result As IAsyncResult)
    Private Delegate Sub StartDelegate()
    Private Delegate Sub StopDelegate()

#Region " Vom Windows Form Designer generierter Code "

    ''' <summary>
    '''   Creates a new instance of <c>MainForm</c>.
    ''' </summary>
    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Private WithEvents StatusBar1 As System.Windows.Forms.StatusBar
    Private WithEvents FolderSelectionButton As System.Windows.Forms.Button
    Private WithEvents Label1 As System.Windows.Forms.Label
    Private WithEvents StartStopButton As System.Windows.Forms.Button
    Private WithEvents Label2 As System.Windows.Forms.Label
    Private WithEvents Label3 As System.Windows.Forms.Label
    Private WithEvents Label4 As System.Windows.Forms.Label
    Private WithEvents FoundFilesListBox As System.Windows.Forms.ListBox
    Private WithEvents FileNamePatternTextBox As System.Windows.Forms.TextBox
    Private WithEvents SearchDirectoryTextBox As System.Windows.Forms.TextBox

    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.StatusBar1 = New System.Windows.Forms.StatusBar
        Me.StartStopButton = New System.Windows.Forms.Button
        Me.SearchDirectoryTextBox = New System.Windows.Forms.TextBox
        Me.FolderSelectionButton = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.FileNamePatternTextBox = New System.Windows.Forms.TextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me.FoundFilesListBox = New System.Windows.Forms.ListBox
        Me.Label4 = New System.Windows.Forms.Label
        Me.SuspendLayout()
        '
        'StatusBar1
        '
        Me.StatusBar1.Location = New System.Drawing.Point(0, 342)
        Me.StatusBar1.Name = "StatusBar1"
        Me.StatusBar1.Size = New System.Drawing.Size(416, 24)
        Me.StatusBar1.TabIndex = 9
        Me.StatusBar1.Text = "StatusBar1"
        '
        'StartStopButton
        '
        Me.StartStopButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.StartStopButton.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.StartStopButton.Location = New System.Drawing.Point(328, 72)
        Me.StartStopButton.Name = "StartStopButton"
        Me.StartStopButton.TabIndex = 5
        Me.StartStopButton.Text = "&Start"
        '
        'SearchDirectoryTextBox
        '
        Me.SearchDirectoryTextBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.SearchDirectoryTextBox.Location = New System.Drawing.Point(16, 32)
        Me.SearchDirectoryTextBox.Name = "SearchDirectoryTextBox"
        Me.SearchDirectoryTextBox.Size = New System.Drawing.Size(352, 21)
        Me.SearchDirectoryTextBox.TabIndex = 1
        Me.SearchDirectoryTextBox.Text = ""
        '
        'FolderSelectionButton
        '
        Me.FolderSelectionButton.Anchor = CType((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.FolderSelectionButton.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.FolderSelectionButton.Location = New System.Drawing.Point(376, 32)
        Me.FolderSelectionButton.Name = "FolderSelectionButton"
        Me.FolderSelectionButton.Size = New System.Drawing.Size(24, 23)
        Me.FolderSelectionButton.TabIndex = 2
        Me.FolderSelectionButton.Text = "&..."
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.Label1.Location = New System.Drawing.Point(16, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(54, 17)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Search &in:"
        '
        'FileNamePatternTextBox
        '
        Me.FileNamePatternTextBox.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.FileNamePatternTextBox.Location = New System.Drawing.Point(16, 72)
        Me.FileNamePatternTextBox.Name = "FileNamePatternTextBox"
        Me.FileNamePatternTextBox.Size = New System.Drawing.Size(296, 21)
        Me.FileNamePatternTextBox.TabIndex = 4
        Me.FileNamePatternTextBox.Text = "*.exe"
        '
        'Label2
        '
        Me.Label2.AutoSize = True
        Me.Label2.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.Label2.Location = New System.Drawing.Point(16, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(96, 17)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "&File name pattern:"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.Label3.Location = New System.Drawing.Point(16, 128)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(62, 17)
        Me.Label3.TabIndex = 7
        Me.Label3.Text = "Fou&nd files:"
        '
        'FoundFilesListBox
        '
        Me.FoundFilesListBox.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.FoundFilesListBox.HorizontalScrollbar = True
        Me.FoundFilesListBox.Location = New System.Drawing.Point(16, 144)
        Me.FoundFilesListBox.Name = "FoundFilesListBox"
        Me.FoundFilesListBox.Size = New System.Drawing.Size(384, 173)
        Me.FoundFilesListBox.TabIndex = 8
        '
        'Label4
        '
        Me.Label4.Anchor = CType(((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.Label4.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label4.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.Label4.Location = New System.Drawing.Point(16, 112)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(384, 2)
        Me.Label4.TabIndex = 6
        '
        'MainForm
        '
        Me.AcceptButton = Me.StartStopButton
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 14)
        Me.ClientSize = New System.Drawing.Size(416, 366)
        Me.Controls.Add(Me.Label4)
        Me.Controls.Add(Me.FoundFilesListBox)
        Me.Controls.Add(Me.FileNamePatternTextBox)
        Me.Controls.Add(Me.FolderSelectionButton)
        Me.Controls.Add(Me.SearchDirectoryTextBox)
        Me.Controls.Add(Me.StartStopButton)
        Me.Controls.Add(Me.StatusBar1)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label3)
        Me.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "'MvpsOrg.Utilities.FileSystemEnumerator' Demo"
        Me.ResumeLayout(False)

    End Sub
#End Region

    Private Property Mode() As OperationMode
        Get
            Return m_Mode
        End Get
        Set(ByVal Value As OperationMode)
            m_Mode = Value
            If Me.Mode = OperationMode.Idle Then
                Me.StartStopButton.Text = "&Start"
                Me.SearchDirectoryTextBox.Enabled = True
                Me.FileNamePatternTextBox.Enabled = True
                Me.FolderSelectionButton.Enabled = True
                Me.StatusBar1.Text = "Ready."
            Else
                Me.StartStopButton.Text = "&Stop"
                Me.SearchDirectoryTextBox.Enabled = False
                Me.FileNamePatternTextBox.Enabled = False
                Me.FolderSelectionButton.Enabled = False
                Me.StatusBar1.Text = "Initializing..."
            End If
        End Set
    End Property

    Private Sub m_Enumerator_FileFound(ByVal sender As Object, ByVal e As FileFoundEventArgs) Handles m_Enumerator.FileFound
        If Me.InvokeRequired Then
            Me.BeginInvoke( _
                New FileFoundDelegate(AddressOf Me.m_Enumerator_FileFound), _
                New Object() {sender, e} _
            )
        Else

            ' Implement a very basic path comparison using 'Like'.
            If Path.GetFileName(e.FileName) Like Me.FileNamePatternTextBox.Text Then
                Me.FoundFilesListBox.Items.Add(e.FileName)
            End If
        End If
    End Sub

    Private Sub m_Enumerator_EnumerationDirectoryChanged(ByVal sender As Object, ByVal e As EnumerationDirectoryChangedEventArgs) Handles m_Enumerator.EnumerationDirectoryChanged
        If Me.InvokeRequired Then
            Me.BeginInvoke( _
                New EnumerationDirectoryChangedDelegate(AddressOf Me.m_Enumerator_EnumerationDirectoryChanged), _
                New Object() {sender, e} _
            )
        Else

            ' Setting status information in the statusbar.  The size calculation is not very
            ' accurate, because we are mixing GDI and GDI+ calculations.
            Dim s As String = "Searching """
            Dim MaxWidth As Integer = Me.StatusBar1.Width - m_StatusBarTextWidth
            If MaxWidth < 0 Then
                MaxWidth = 0
            End If
            Dim t As String = _
                CompactPath( _
                    e.Path, _
                    m_StatusBarGraphics, _
                    MaxWidth _
                )
            If t Is Nothing Then
                s &= e.Path
            Else
                s &= t
            End If
            s &= """..."
            Me.StatusBar1.Text = s
        End If
    End Sub

    Private Sub SearchFinished(ByVal Result As IAsyncResult)
        If Me.InvokeRequired Then
            Me.BeginInvoke( _
                New SearchFinishedDelegate(AddressOf SearchFinished), _
                New Object() {Result} _
            )
        Else
            Me.Mode = OperationMode.Idle
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_StatusBarGraphics = Me.StatusBar1.CreateGraphics()

        ' That's not very accurate because we are using GDI to draw the text and GDI+
        ' is used for measuring.
        m_StatusBarTextWidth = _
            CInt(m_StatusBarGraphics.MeasureString("Searching: """"...", Me.StatusBar1.Font).Width)

        Me.SearchDirectoryTextBox.Text = Environment.CurrentDirectory
        Me.Mode = OperationMode.Idle
    End Sub

    Private Sub MainForm_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If Me.Mode = OperationMode.Enumerating Then
            Me.StartStopButton.PerformClick()
        End If
        m_StatusBarGraphics.Dispose()
    End Sub

    Private Sub StartStopButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartStopButton.Click
        If Me.Mode = OperationMode.Idle Then
            Me.Mode = OperationMode.Enumerating
            If Not Directory.Exists(Me.SearchDirectoryTextBox.Text) Then
                MessageBox.Show("The directory """ & Me.SearchDirectoryTextBox.Text & """ does not exist.", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If
            If Me.FoundFilesListBox.Items.Count > 0 Then
                Me.FoundFilesListBox.Items.Clear()
            End If
            m_Enumerator.StartDirectory = Me.SearchDirectoryTextBox.Text
            Dim d As New StartDelegate(AddressOf m_Enumerator.Start)
            d.BeginInvoke(New AsyncCallback(AddressOf SearchFinished), Nothing)
        Else
            Me.Mode = OperationMode.Idle
            m_Enumerator.Stop()
            Dim d As New StopDelegate(AddressOf m_Enumerator.Stop)
            d.Invoke()
        End If
    End Sub

    Private Sub FolderSelectionButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FolderSelectionButton.Click
        Dim f As New FolderBrowserDialog
        f.Description = "Select the folder where search should be done."
        If Directory.Exists(Me.SearchDirectoryTextBox.Text) Then
            f.SelectedPath = Me.SearchDirectoryTextBox.Text
        End If
        If f.ShowDialog() = DialogResult.OK Then
            Me.SearchDirectoryTextBox.Text = f.SelectedPath
        End If
        f.Dispose()
    End Sub

    Private Declare Auto Function PathCompactPath Lib "shlwapi.dll" ( _
        ByVal hDC As IntPtr, _
        ByVal lpszPath As String, _
        ByVal dx As Int32 _
    ) As Boolean

    Private Function CompactPath( _
        ByVal Path As String, _
        ByVal Destination As Graphics, _
        ByVal MaxWidth As Integer _
    ) As String
        Dim hDC As IntPtr = Destination.GetHdc()
        Dim Success As Boolean = PathCompactPath(hDC, Path, MaxWidth)
        Destination.ReleaseHdc(hDC)
        If Success Then
            Dim p As Integer = Strings.InStr(Path, ControlChars.NullChar) - 1
            If p > 0 Then
                Return Strings.Left(Path, p)
            Else
                Return Path
            End If
        Else
            Return Nothing
        End If
    End Function
End Class