Option Compare Binary
Option Explicit On 
Option Strict On

Imports System

''' <summary>
'''   Provides data for the <c>DirectoryFound</c> event.
''' </summary>
Public Class DirectoryFoundEventArgs
    Inherits EventArgs

    Private m_CancelEnumeration As Boolean
    Private m_DirectoryName As String

    ''' <summary>
    '''   Creates a new instance of <c>DirectoryFoundEventArgs</c>.
    ''' </summary>
    Public Sub New(ByVal DirectoryName As String)
        Me.DirectoryName = DirectoryName
    End Sub

    ''' <summary>
    '''   Gets or sets a value indicating that further enumeration of subdirectories should be cancelled.
    ''' </summary>
    ''' <value>A value indicating that further enumeration of subdirectories should be cancelled.</value>
    Public Property CancelEnumeration() As Boolean
        Get
            Return m_CancelEnumeration
        End Get
        Set(ByVal Value As Boolean)
            m_CancelEnumeration = Value
        End Set
    End Property

    ''' <summary>
    '''   Gets or sets the name of the file system object that was found.
    ''' </summary>
    ''' <value>The name of the file system object that was found.</value>
    Public Property DirectoryName() As String
        Get
            Return m_DirectoryName
        End Get
        Set(ByVal Value As String)
            m_DirectoryName = Value
        End Set
    End Property
End Class