Option Compare Binary
Option Explicit On 
Option Strict On

Imports System

''' <summary>
'''   Provides data for the <c>EnumerationDirectoryChanged</c> event.
''' </summary>
Public Class EnumerationDirectoryChangedEventArgs
    Inherits EventArgs

    Private m_Path As String

    ''' <summary>
    '''   Creates a new instance of <c>EnumerationDirectoryChangedEventArgs</c>.
    ''' </summary>
    Public Sub New(ByVal Path As String)
        Me.Path = Path
    End Sub

    ''' <summary>
    '''   Gets or sets the name of the directory that is currently searched in.
    ''' </summary>
    ''' <value>The name of the directory that is currently searched in.</value>
    Public Property Path() As String
        Get
            Return m_Path
        End Get
        Set(ByVal Value As String)
            m_Path = Value
        End Set
    End Property
End Class