Option Compare Binary
Option Explicit On 
Option Strict On

Imports System

''' <summary>
'''   Provides data for the <c>FileFound</c> event.
''' </summary>
Public Class FileFoundEventArgs
    Inherits EventArgs

    Private m_FileName As String

    ''' <summary>
    '''   Creates a new instance of <c>FileFoundEventArgs</c>.
    ''' </summary>
    Public Sub New(ByVal FileName As String)
        Me.FileName = FileName
    End Sub

    ''' <summary>
    '''   Gets or sets the name of the file system object that was found.
    ''' </summary>
    ''' <value>The name of the file system object that was found.</value>
    Public Property FileName() As String
        Get
            Return m_FileName
        End Get
        Set(ByVal Value As String)
            m_FileName = Value
        End Set
    End Property
End Class